echo off
title Dedicated Server Opener v2.0.1

rem You are allowed to freely modify the code as you desire.
rem Just be aware that some batch instructions are dangerous.
rem Go to trusty websites like StackOverflow to ask for problems with your code.
rem Any line that starts with rem means it's a comment. Like this one!

rem Checks if the game is installed.
set gameexists=0
if exist "%userprofile%\SRB2 v2.2\srb2win.exe" set gameexists=2
if exist .\srb2win.exe set gameexists=1
if %gameexists% ==0 goto nogameleave

rem If that's true, then initializes other variables and continues
set connect=0
set room=0
cls

rem This piece of code lets the user know where the script will run the game off
if %gameexists% ==1 echo This script is working on the same directory the game is in.
if %gameexists% ==2 echo This script is working on the default installation folder.
echo.

rem Password check for the server
echo If you don't want to use any password, then just press enter.
set /p password=Insert desired password: 
if "%password%" == "" set password=0

rem Port check for the server
echo Now, the port you wanna use for the server. Press enter to use default of 5029.
set /p port=Insert port number:
if "%port%" == "" set port=5029

rem Room check to list the server on the default master server
:roomchoice
cls
echo List of Master server rooms:
echo a: Unlisted
echo b: Standard
echo c: Casual
echo d: OLDC
echo e: Custom Gametypes
echo.
choice /c abcde /m "Insert room letter: "

if ERRORLEVEL ==255 (
	cls
	echo There was an error while reading your option...
	echo Please try again.
	echo.
	goto roomchoice
)
if ERRORLEVEL ==5 goto custom
if ERRORLEVEL ==4 goto oldc
if ERRORLEVEL ==3 goto casual
if ERRORLEVEL ==2 goto standard
if ERRORLEVEL ==1 goto unlisted

goto error

rem Five "Funtions" that ask the user if they want to connect to the server and launches the dedicated server accordingly.

:unlisted
set room=1
if %connect% ==0 goto connectchoice
if %password% ==0 (
	echo echo Starting unlisted dedicated server at port %port%
) else (
	echo Starting unlisted dedicated server with admin password %password% at port %port%
)
if %gameexists% ==1 start srb2win.exe -dedicated +password %password% -maxsend max -port %port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -dedicated +password %password% -maxsend max -port %port%
if %connect% ==1 goto connect
goto leave

:standard
set room=2
if %connect% ==0 goto connectchoice
if %password% ==0 (
	echo Starting dedicated server at standard room at port %port%
) else (
	echo Starting dedicated server at standard room with admin password %password% at port %port%
)
if %gameexists% ==1 start srb2win.exe -dedicated -room 33 +password %password% -maxsend max -port %port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -dedicated -room 33 +password %password% -maxsend max -port %port%
if %connect% ==1 goto connect
goto leave

:casual
set room=3
if %connect% ==0 goto connectchoice
if %password% ==0 (
	echo Starting dedicated server at casual room at port %port%
) else (
	echo Starting dedicated server at casual room with admin password %password% at port %port%
)
if %gameexists% ==1 start srb2win.exe -dedicated -room 28 +password %password% -maxsend max -port %port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -dedicated -room 28 +password %password% -maxsend max -port %port%
if %connect% ==1 goto connect
goto leave

:oldc
set room=4
if %connect% ==0 goto connectchoice
if %password% ==0 (
	echo Starting dedicated server at OLDC room at port %port%
) else (
	echo Starting dedicated server at OLDC room with admin password %password% at port %port%
)
if %gameexists% ==1 start srb2win.exe -dedicated -room 31 +password %password% -maxsend max -port %port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -dedicated -room 31 +password %password% -maxsend max -port %port%
if %connect% ==1 goto connect
goto leave

:custom
set room=5
if %connect% ==0 goto connectchoice
if %password% ==0 (
	echo Starting dedicated server at custom gametype room at port %port%
) else (
	echo Starting dedicated server at custom gametype room with admin password %password% at port %port%
)
if %gameexists% ==1 start srb2win.exe -dedicated -room 38 +password %password% -maxsend max -port %port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -dedicated -room 38 +password %password% -maxsend max -port %port%
if %connect% ==1 goto connect
goto leave


rem Check done to see if user wants to open a game client to join the just launched server
:connectchoice
cls
choice /n /c yn /m "Do you want to connect to the server? (y/n) "
if %ERRORLEVEL% ==255 (
	cls
	echo There was an error while reading your option...
	echo Please try again.
	echo.
	goto connectchoice
)
if %ERRORLEVEL% ==2 set connect=2
if %ERRORLEVEL% ==1 set connect=1

:dedicated
if %room% ==1 goto unlisted
if %room% ==2 goto standard
if %room% ==3 goto casual
if %room% ==4 goto oldc
if %room% ==5 goto custom

:error
cls
echo An unhandled error ocurred.
echo Please report this issue by sending all the data you inserted to the person who made this script.
echo If you got this from the Sonic Robo Blast 2 Addons & more page, then send that data to Eloy.
echo The script will close now.
pause
goto leave

:connect
echo Starting game client...
if %gameexists% ==1 start srb2win.exe -connect localhost:%port%
if %gameexists% ==2 start /d %userprofile%\"SRB2 v2.2" %userprofile%\"SRB2 v2.2"\srb2win.exe -connect localhost:%port%
goto leave

:nogameleave
cls
echo Is the batch file in the same directory as the game?
echo Is the game installed in the default directory?
echo Either way, the game was not found. Please check for these problems and try again.
pause

:leave
echo Script finished working...
echo on || exit /b